#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    find_minmax({1, 3}, min, max);
    CHECK(min == 1);
    CHECK(max == 3);
}

TEST_CASE("empty vector") {
    double min = 0;
    double max = 0;
    find_minmax({}, min, max);
    CHECK(min == 0);
    CHECK(max == 0);
}

TEST_CASE("vectors with one element") {
    double min = 0;
    double max = 0;
    find_minmax({9}, min, max);
    CHECK(min == 9);
    CHECK(max == 9);
}


TEST_CASE("distinct negative numbers") {
    double min = 0;
    double max = 0;
    find_minmax({-3, -5}, min, max);
    CHECK(min == -5);
    CHECK(max == -3);
}


TEST_CASE("vectors of identical elements") {
    double min = 0;
    double max = 0;
    find_minmax({5, 5, 5, 5}, min, max);
    CHECK(min == 5);
    CHECK(max == 5);
}
